--
-- coup
--
-- Copyright (c) 2014-2016, rnlf
--
-- This library is free software; you can redistribute it and/or modify it
-- under the terms of the MIT license. See LICENSE for details.
--

local Array2D = {}
Array2D.__index = Array2D

function Array2D:index(x, y) 
  return y*self.width+x+1
end

function Array2D:get(x, y) 
  return self.data[y*self.width+x+1]
end

function Array2D:set(x, y, v) 
  self.data[y*self.width+x+1] = v
end

return function(width, height_or_data)
  local new
  if type(height_or_data) ~= "table" then
    new = {
      width = width,
      height = height_or_data,
      data = {}
    }
  else
    new = {
      width = width,
      height = math.floor(#height_or_data / width),
      data = height_or_data
    }
  end

  return setmetatable(new, Array2D)
end
