--
-- coup
--
-- Copyright (c) 2014-2016, rnlf
--
-- This library is free software; you can redistribute it and/or modify it
-- under the terms of the MIT license. See LICENSE for details.
--

local resultkey = {}
local nilkey = {}
return function(func)
  local cache = {}

  return function(...)
    local t = cache
    for i = 1, select('#', ...) do
      local v = select(i, ...) or nilkey
      local tn = t[v] or {}
      t[v] = tn
      t = tn
    end
    local r = t[resultkey] or {func(...)}
    t[resultkey] = r
    return unpack(r)
  end
end
