--
-- coup
--
-- Copyright (c) 2014-2016, rnlf
--
-- This library is free software; you can redistribute it and/or modify it
-- under the terms of the MIT license. See LICENSE for details.
--

local function getScreenSize()
  local canvas = love.graphics.getCanvas()
  local dimX, dimY
  local vec = coup.vector.Vector
  if canvas then
    return vec(canvas:getDimensions())
  else
    local x, y = love.window.getMode()
    return vec(x, y)
  end
end

local function cameraSettings(topLeft, bottomRight)
  local cam_size = bottomRight - topLeft
  local screen_size = getScreenSize()
  local screen_offset = (screen_size - cam_size) / 2 
  local offset = screen_offset - topLeft

  return cam_size, screen_offset, offset
end


return {
  cameraSettings = cameraSettings,
  getScreenSize = getScreenSize
}
