--
-- coup
--
-- Copyright (c) 2014-2016, rnlf
--
-- This library is free software; you can redistribute it and/or modify it
-- under the terms of the MIT license. See LICENSE for details.
--

local BASE = ...

local componentTypes = {
  Transform              = require(BASE .. ".transform"),
  Flag                   = require(BASE .. ".flag"),
  AxisAlignedBoundingBox = require(BASE .. ".axisalignedboundingbox"),
  BoundingBox            = require(BASE .. ".boundingbox"),
  Velocity               = require(BASE .. ".velocity"),
  AngularVelocity        = require(BASE .. ".angularvelocity"),
  Sprite                 = require(BASE .. ".sprite")
}


function registerComponentTypes(world)
  local comps = {
    Transform              = "Transform",
    OldTransform           = "Transform",
    BoundingBox            = "BoundingBox",
    AxisAlignedBoundingBox = "AxisAlignedBoundingBox",
    AABBChanged            = "AABBChanged",
    TransformChanged       = "TransformChanged",
    Velocity               = "Velocity",
    AngularVelocity        = "AngularVelocity",
    Sprite                 = "Sprite",
    AABBChanged            = "Flag",
    TransformChanged       = "Flag"
  }

  for name, comptype in pairs(comps) do
    world:registerComponentType(name, componentTypes[comptype]())
  end
end


return {
  types = componentTypes,
  ComponentStore = require(BASE .. ".componentstore"),
  register = registerComponentTypes
}
