--
-- coup
--
-- Copyright (c) 2014-2016, rnlf
--
-- This library is free software; you can redistribute it and/or modify it
-- under the terms of the MIT license. See LICENSE for details.
--

local function loadAll(datadir, animRepo, loadFunc)
  
  for i, f in ipairs(love.filesystem.getDirectoryItems(datadir)) do
    local df = datadir .. "/" .. f
    if love.filesystem.getInfo(df, 'file') then
      if f:find(".json$") then
        coup.asepriteloader.loadAsepriteFile(df, animRepo, loadFunc)
      end
    elseif love.filesystem.getInfo(df, 'directory') then
      loadAll(df, animRepo, loadFunc)
    end
  end
end

return { loadAll = loadAll }
