--
-- coup
--
-- Copyright (c) 2014-2016, rnlf
--
-- This library is free software; you can redistribute it and/or modify it
-- under the terms of the MIT license. See LICENSE for details.
--

local SpriteUpdater = {}
SpriteUpdater.__index = SpriteUpdater

function SpriteUpdater:updateSprites(dt)
  self.world:foreachEntityWithComponents(function(spr)
    spr:getComponent("Sprite").sprite:update(dt)
  end, "Sprite")

end


local function newSpriteUpdater(world)
  return setmetatable({
    world = world
  }, SpriteUpdater)
end

return newSpriteUpdater


