--
-- coup
--
-- Copyright (c) 2014-2016, rnlf
--
-- This library is free software; you can redistribute it and/or modify it
-- under the terms of the MIT license. See LICENSE for details.
--

local VelocityUpdater = {}
VelocityUpdater.__index = VelocityUpdater


function VelocityUpdater:update(dt)
  self.world:foreachEntityWithComponents(function(e)
    local v = e:getComponent("Velocity")
    local t = e:getComponent("Transform")

    t.pos = t.pos + v.vel * dt
  end, "Velocity", "Transform")
end


local function newVelocityUpdater(world)
  local self = {
    world = world
  }

  return setmetatable(self, VelocityUpdater)
end


return newVelocityUpdater
