--
-- coup
--
-- Copyright (c) 2014-2016, rnlf
--
-- This library is free software; you can redistribute it and/or modify it
-- under the terms of the MIT license. See LICENSE for details.
--

package.path = "../coup/?.lua;?.lua"
local array2d = require "array2d"
local test = require "test"

test.group("array2d")

:case("default constructor", function()
  local a = array2d(10, 20)

  assert(type(a) == 'table')

  assert(a.width == 10)
  assert(a.height == 20)
  assert(a:index(0, 1) == 11)
  assert(a:index(1, 2) == 22)

  a:set(5, 5, 10)
  assert(a:get(5,5) == 10)
end)


:case("construct with existing data", function()
  local data = {
    11, 12, 13, 14, 15,
    21, 22, 23, 24, 25,
    31, 32, 33, 34, 35,
    41, 42, 43, 44, 45,
  }

  local a = array2d(5, data)

  assert(type(a) == 'table')
  assert(a.width == 5)
  assert(a.height == 4)
  assert(a:get(2, 3) == 43)
  assert(a:get(4, 2) == 35) 
end)
