return function()
  return {
    dustSpawn = 0,
    dusts = {},
    emit = function (self, rate, emitPosFunc, dt)
      self.dustSpawn = self.dustSpawn + dt * rate
      for i = 1, self.dustSpawn do
        if love.math.random() < 0.25 then
          local torchPos = emitPosFunc((i-1)/math.floor(self.dustSpawn))
          self.dusts[#self.dusts+1] = {
            x = torchPos[1],
            y = torchPos[2]+2,
            speed = love.math.randomNormal(5, 10),
            life = 2, -- love.math.randomNormal(1,3),
            drift = love.math.randomNormal(20, 0),
            grow = love.math.randomNormal(5, 10),
            size = 0
          }
        end
      end
      self.dustSpawn = self.dustSpawn - math.floor(self.dustSpawn)
    end,
    update = function(self, dt)
      for i = #self.dusts,1,-1 do
        local s = self.dusts[i]
        s.life = s.life - dt
        if s.life <= 0 then
          self.dusts[i], self.dusts[#self.dusts] = self.dusts[#self.dusts], self.dusts[i]
          self.dusts[#self.dusts] = nil
        else
          s.y = s.y - dt*s.speed
          s.size = s.size + dt*s.grow
        end
      end
    end,
    draw = function(self)
      local threshold = 1.5 
      local baseline = 0.7
      local can = love.graphics.getCanvas()
      love.graphics.setBlendMode('alpha')
      for i, p in pairs(self.dusts) do
        local l
        if p.life > threshold then
          l = baseline
        else
          l = (baseline/threshold) * p.life
        end
        love.graphics.setColor(0,0,0,l)
        love.graphics.circle('fill', p.x, p.y, p.size)
      end
      love.graphics.setColor(1,1,1,1)
    end
  }
end

