HC = require 'HardonCollider'
require "coup.coup"
World = require "world"
screen = require "screen"
torch = require "torch"

function newGame()
  G.world = World()
  for i = 1, 3 do
    G.ambient[i]:setLooping(true)
    G.ambient[i]:setVolume(0.3)
    G.ambient[i]:play()
  end
  G.world:update(0)
end

function love.load()
  G = {}
  G.font = love.graphics.newFont("data/font.ttf", 64)
  love.graphics.setFont(G.font)
  G.screenSize = {screen.logicalSize.width, screen.logicalSize.height}
  G.loadImage = coup.cache(love.graphics.newImage)
  G.animRepo  = coup.sprite.AnimationRepository()
  G.torch = G.loadImage('data/torch.png')
  G.torch_glow = G.loadImage('data/torch_glow.png')
  G.torch_light = G.loadImage('data/torch_light.png')
  G.streak = G.loadImage('data/streak.png')

  coup.spriteloader.loadAll("data/sprites", G.animRepo, G.loadImage) 
  G.torches = torch.load("data/torch_pos")

  G.canvas = love.graphics.newCanvas(G.screenSize[1], G.screenSize[2])
  G.canvas:setFilter('nearest', 'nearest')
  G.ambient = {
    love.audio.newSource('data/ambient-1.ogg', 'stream'),
    love.audio.newSource('data/ambient-2.ogg', 'stream'),
    love.audio.newSource('data/ambient-3.ogg', 'stream'),
  }
  G.pounce = love.audio.newSource('data/pounce.ogg', 'static')
  G.step = love.audio.newSource('data/step.wav', 'static')
  G.heartbeat = love.audio.newSource('data/heartbeat.wav', 'static')
  G.heartbeat2 = G.heartbeat:clone()
  G.heartbeat2:setPitch(1.01)
  G.drop = love.audio.newSource('data/drop.wav', 'static')
  newGame()


end


function love.update(dt)
  G.world:update(dt)

  if G.world.dead_state == "show_message" and love.keyboard.isDown('x') then
    newGame()
  end
end


function love.draw()
  love.graphics.setCanvas(G.canvas)
  G.world:draw()
  love.graphics.setCanvas()
  local w, h = love.graphics.getDimensions()
  local sx = w / G.screenSize[1]
  local sy = h / G.screenSize[2]
  love.graphics.draw(G.canvas, 0, 0, 0, sx, sy)
end
