local function make(hc, x, y, w, h)

  local collider
  if type(w) == "table" then
    collider = hc:addPolygon(unpack(w))
  else
    collider = hc:addRectangle(0, 0, w, h)
  end

  local comp = {
    x = x,
    y = y,
    collider = collider,
    hc = hc
  }
  comp.collider.owner = comp

  return comp
end

return function()
  local store = coup.components.ComponentStore(make)
  store:onRemove(function(comp)
    comp.hc:remove(comp.collider)
  end)
  return store
end
