PlayerProcessor = coup.class({})

function PlayerProcessor:new(world)
  self.world = world
end

function PlayerProcessor:update()
  self.world.world:foreachEntityWithComponents(function(e)
    inp = e:getComponent("Input")
    vel = e:getComponent("Velocity")
    sen = e:getComponent("Sensors")
    spr = e:getComponent("Sprite")
    tra = e:getComponent("Transform")

    local onGround = sen.sensors.foot:touchesGround(self.world.collider)
    local onLeft = sen.sensors.left:touchesGround(self.world.collider)
    local onRight = sen.sensors.right:touchesGround(self.world.collider)

    if onGround then
      local py = tra:lpos(1).y
      if e.last_ground and (py > e.last_ground + 400) then
        self.world:kill('drop')
      end

      e.last_ground = py
    end

    local slow = inp.walk

    vel.max_vel.x = slow and 60 or 200


    local acc_done = false
    if not onLeft and inp.left then
      vel.acc.x = -2000
      acc_done = true
    end

    if not onRight and inp.right then
      vel.acc.x =  2000
      acc_done = true
    end

    if not acc_done then
      vel.acc.x = 0
    end

    if inp.jump and not inp.lastJump then
      if onGround then
        vel.vel.y = -300
        inp.allowDouble = true
      end
    end

    vel.acc.y = 0
    if not onGround then
      vel.hor_drag = 200
      if vel.vel.y < 0 then
        if inp.jump then
          vel.acc.y = -200 -- counteract a bit of gravity
        else
          vel.acc.y = 1500
        end
      end
    else
      vel.hor_drag = 1000
    end

    inp.lastJump = inp.jump

    if vel.vel.x > 0 then
      tra.scale.x = 1
      inp.last_dir = "R"
    elseif vel.vel.x < 0 then
      tra.scale.x = -1
      inp.last_dir = "L"
    end

    if onGround  then
      if math.abs(vel.vel.x) > 10 then
        if slow then
          spr.sprite:play("Walk", true)
        else
          spr.sprite:play("Run", true)
        end
      else
        spr.sprite:play("Idle", true)
      end
    else
      local updown = "Drop";
      if vel.vel.y < 0 then
        updown = "Jump"
      end
      spr.sprite:play(updown, true)
      --[[
      if vel.vel.x > 0 then
        inp.last_dir = "R"
      elseif vel.vel.x < 0 then
        spr.sprite:play(updown .. "L", true)
        inp.last_dir = "L"
      else
        spr.sprite:play(updown .. inp.last_dir, true)
      end
      ]]
    end


  end, "Input", "Transform", "Velocity", "Sprite", "Sensors")

end
