local SensorsMT = { }
SensorsMT.__index = SensorsMT

local SensorMT = {}
SensorMT.__index = SensorMT

function SensorsMT:addSensor(coll, name, x, y, w, h)
  local sensor = coll:addRectangle(0, 0, w, h)
  local newSensor = setmetatable({x = x, y = y, sensor = sensor, state = false}, SensorMT)

  sensor.isSensor = true
  --coll:setPassive(sensor)
  self.sensors[name] = newSensor
end


function SensorMT:touchesGround(coll)
  for shape in pairs(coll:shapesInRange(self.sensor:bbox())) do
    if shape.islevel then
      if self.sensor:collidesWith(shape) then
        return true
      end
    end
  end
  return false
end

local function make()
  return setmetatable({
    sensors = {}
  }, SensorsMT)

end

return function()
  return coup.components.ComponentStore(make)
end

