return function()
  return {
    sparkSpawn = 0,
    sparks = {},
    emit = function (self, torchPosFunc, dt)
      self.sparkSpawn = self.sparkSpawn + dt * 20
      for i = 1, self.sparkSpawn do
        if love.math.random() < 0.25 then
          local torchPos = torchPosFunc((i-1)/math.floor(self.sparkSpawn))
          self.sparks[#self.sparks+1] = {
            x = torchPos[1] + love.math.randomNormal(3, 0),
            y = torchPos[2] - love.math.randomNormal(3, 3),
            phase = love.math.random() * 2 * 3.14159,
            speed = love.math.randomNormal(10, 100),
            amplitude = love.math.randomNormal(3, 4),
            life = 1.5, -- love.math.randomNormal(1,3),
            drift = love.math.randomNormal(20, 0)
          }
        end
      end
      self.sparkSpawn = self.sparkSpawn - math.floor(self.sparkSpawn)
    end,
    update = function(self, dt)
      for i = #self.sparks,1,-1 do
        local s = self.sparks[i]
        s.life = s.life - dt
        if s.life <= 0 then
          self.sparks[i], self.sparks[#self.sparks] = self.sparks[#self.sparks], self.sparks[i]
          self.sparks[#self.sparks] = nil
        else
          s.y = s.y - dt*s.speed
          s.x = s.x + dt*s.drift
          s.phase = s.phase + dt*s.speed/10
        end
      end
    end,
    draw = function(self)
      local threshold = 1
      local baseline = 0.7
      local can = love.graphics.getCanvas()
      love.graphics.setBlendMode('add')
      for i, p in pairs(self.sparks) do
        local l
        if p.life > threshold then
          l = baseline
        else
          l = (baseline/threshold) * p.life
        end
        love.graphics.setColor(l,l,l,1)
        love.graphics.line(p.x+p.amplitude*math.sin(p.phase), p.y, p.x+p.amplitude*math.sin(p.phase-0.1), p.y+2)
      end
      love.graphics.setColor(1,1,1,1)
    end
  }
end

